petsc-3.4.2 2013-07-02

# VecGetArrayRead

Get read-only pointer to contiguous array containing this processor's portion of the vector data.

### Synopsis

    #include "petscvec.h"
    PetscErrorCode VecGetArrayRead(Vec x,const PetscScalar **a)

Not Collective

### Input Parameters

x -the vector

### Output Parameter

a -the array

### Notes

The array must be returned using a matching call to VecRestoreArrayRead().

Unlike VecGetArray(), this routine is not collective and preserves cached information like vector norms.

Standard PETSc vectors use contiguous storage so that this routine does not perform a copy. Other vector implementations may require a copy, but must such implementations should cache the contiguous representation so that only one copy is performed when this routine is called multiple times in sequence.

### See Also

VecGetArray(), VecRestoreArray()

Level:beginner
Location:src/vec/vec/interface/rvector.c
Index of all Vec routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/snes/examples/tutorials/ex1.c.html
src/snes/examples/tutorials/ex2.c.html
src/snes/examples/tutorials/ex31.c.html
src/snes/examples/tutorials/ex54.c.html
src/snes/examples/tutorials/ex55.c.html
src/snes/examples/tutorials/ex61.c.html
src/snes/examples/tutorials/ex63.c.html
src/snes/examples/tutorials/ex633d_db.c.html
src/snes/examples/tutorials/ex64.c.html
src/snes/examples/tutorials/ex65.c.html
src/ts/examples/tutorials/ex16.c.html